assert(TrackCooldowns, "TrackCooldowns not found!") 

local hero = (UnitFactionGroup("player") == "Alliance") and 32182 or 2825
local cooldowns = {

    ["DEATHKNIGHT"] = { 
        [GetSpellInfo(48707)] = { id = 48707, cd = 45 },			-- Anti-magic Shell
        [GetSpellInfo(49222)] = { id = 49222, cd = 60 },			-- Bone Shield  
        [GetSpellInfo(48792)] = { id = 48792, cd = 180 },			-- Icebound Fortitude 
        [GetSpellInfo(55233)] = { id = 55233, cd = 60 },			-- Vampiric Blood
        [GetSpellInfo(48982)] = { id = 48982, cd = 30 },			-- Rune Tap
        [GetSpellInfo(61999)] = { id = 61999, cd = 600 },			-- Raise Ally
        [GetSpellInfo(56222)] = { id = 56222, cd = 8 },				-- Dark Command
		[GetSpellInfo(49576)] = { id = 49576, cd = 25 },			-- Death Grip
		[GetSpellInfo(47528)] = { id = 47528, cd = 15 },			-- Mind Freeze
		[GetSpellInfo(47476)] = { id = 47476, cd = 120 },			-- Strangulate
		[GetSpellInfo(108199)] = { id = 108199, cd = 60 },			-- Gorefiend's Grasp
		[GetSpellInfo(108200)] = { id = 108200, cd = 60 },			-- Remoreless Winter
		[GetSpellInfo(108201)] = { id = 108201, cd = 120 },			-- Desecrated Ground
		[GetSpellInfo(48743)] = { id = 48743, cd = 120 },			-- Death Pact
		[GetSpellInfo(51052)] = { id = 51052, cd = 120 },			-- Anti-Magic Zone
    },

    ["DRUID"] = { 
        [GetSpellInfo(22812)] = { id = 22812, cd = 60 },			-- Barkskin
        [GetSpellInfo(29166)] = { id = 29166, cd = 180 },			-- Innervate  
        [GetSpellInfo(20484)] = { id = 20484, cd = 600, ora = 1 },	-- Rebirth 
        [GetSpellInfo(740)]   = { id =   740, cd = 480 },			-- Tranquility
		[GetSpellInfo(132469)] = { id = 132469, cd = 20 },			-- Typhoon
		[GetSpellInfo(6795)]  = { id =  6795, cd = 8 },				-- Growl
		[GetSpellInfo(106839)] = { id = 106839, cd = 15 },			-- Skull Bash
		[GetSpellInfo(78675)] = { id = 78675, cd = 60 },			-- Solar Beam
		[GetSpellInfo(102342)] = { id = 102342, cd = 120 },			-- Ironbark 
		[GetSpellInfo(33891)] = { id = 33891, cd = 180 },			-- Incarnation: Tree of Life
		[GetSpellInfo(108288)] = { id = 108288, cd = 360 },			-- Heart of the Wild
		[GetSpellInfo(124974)] = { id = 124974, cd = 180 },			-- Nature's Vigil
		[GetSpellInfo(106922)] = { id = 106922, cd = 180 },			-- Might of Ursoc
		[GetSpellInfo(112071)] = { id = 112071, cd = 180 },			-- Celestial Alignment
    },

    ["HUNTER"] = { 
		[GetSpellInfo(5384)]  = { id = 5384,  cd = 30 },			-- Feign Death
		[GetSpellInfo(34477)] = { id = 34477, cd = 30 },			-- Misdirection
		[GetSpellInfo(19263)] = { id = 19263, cd = 120 },			-- Deterrence
		[GetSpellInfo(34490)] = { id = 34490, cd = 20 },			-- Silencing Shot
		
		--[GetSpellInfo(781)] = { id = 781, cd = 25 },				-- Disengage
		--[GetSpellInfo(121818)] = { id = 121818, cd = 300 },			-- Stampede
		--[GetSpellInfo(109259)] = { id = 109259, cd = 60 },			-- Powershot
		--[GetSpellInfo(19386)] = { id = 19386, cd = 60 },			-- Wyvern Sting
		--[GetSpellInfo(131894)] = { id = 131894, cd = 120 },			-- A Murder of Crows
		--[GetSpellInfo(120360)] = { id = 120360, cd = 30 },			-- Barrage
		--[GetSpellInfo(109248)] = { id = 109248, cd = 45 },			-- Binding Shot
		--[GetSpellInfo(130392)] = { id = 130392, cd = 20 },			-- Blink Strike
		--[GetSpellInfo(120679)] = { id = 120679, cd = 30 },			-- Dire Strike
		--[GetSpellInfo(109304)] = { id = 109304, cd = 120 },			-- Exhilaration
		--[GetSpellInfo(82726)] = { id = 82726, cd = 30 },			-- Fervor
    },

    ["MAGE"] = {
        [GetSpellInfo(80353)] = { id = 80353, cd = 300 },			-- Time Warp
		[GetSpellInfo(45438)] = { id = 45438, cd = 300 },			-- Ice Block
		[GetSpellInfo(66)]    = { id =    66, cd = 300 },			-- Invisibility
		[GetSpellInfo(113724)] = { id = 113724, cd = 30 },			-- Ring of Frost
		[GetSpellInfo(2139)]  = { id = 2139,  cd = 24 },			-- Counterspell
    },

    ["PALADIN"] = { 
        [GetSpellInfo(498)]   = { id =   498, cd = 60 },			-- Divine Protection  
        [GetSpellInfo(642)]   = { id =   642, cd = 300 },			-- Divine Shield
        [GetSpellInfo(31850)] = { id = 31850, cd = 180 },			-- Ardent Defender 
        [GetSpellInfo(1022)]  = { id =  1022, cd = 300 },			-- Hand of Protection  
        [GetSpellInfo(6940)]  = { id =  6940, cd = 120 },			-- Hand of Sacrifice 
        [GetSpellInfo(1038)]  = { id =  1038, cd = 120 },			-- Hand of Salvation 
		[GetSpellInfo(1044)]  = { id =  1044, cd = 25 },			-- Hand of Freedom 
        [GetSpellInfo(633)]   = { id =   633, cd = 600 },			-- Lay on Hands
        [GetSpellInfo(31821)] = { id = 31821, cd = 180 },			-- Devotion Aura
        [GetSpellInfo(54428)] = { id = 54428, cd = 120 },			-- Divine Plea
        [GetSpellInfo(62124)] = { id = 62124, cd = 8 },				-- Hand of Reckoning
		[GetSpellInfo(96231)] = { id = 96231, cd = 15 },			-- Rebuke
		[GetSpellInfo(114916)] = { id = 114916, cd = 60 },			-- Execution Sentence
		[GetSpellInfo(114917)] = { id = 114917, cd = 60 },			-- Stay of Execution
		[GetSpellInfo(114165)] = { id = 114165, cd = 20 },			-- Holy Prism
		[GetSpellInfo(114158)] = { id = 114158, cd = 60 },			-- Light's Hammer
		[GetSpellInfo(105809)] = { id = 105809, cd = 120 },			-- Holy Avenger
		[GetSpellInfo(31884)] = { id = 31884, cd = 180 },			-- Avenging Wrath
		[GetSpellInfo(85499)] = { id = 85499, cd = 45 },			-- Speed of Light
		
		--[GetSpellInfo(86698)] = { id = 86698, cd = 300 },			-- Guardian of Ancient Kings (Ret)
		--[GetSpellInfo(86669)] = { id = 86669, cd = 300 },			-- Guardian of Ancient Kings (Holy)
		--[GetSpellInfo(86659)] = { id = 86659, cd = 180 },			-- Guardian of Ancient Kings (Protection)
		--[GetSpellInfo(86150)] = { id = 86150, cd = 180 },			-- Guardian of Ancient Kings // All specs, cannot track only protection
		
    },

    ["PRIEST"] = { 
        [GetSpellInfo(64843)] = { id = 64843, cd = 180 },			-- Divine Hymn 
        [GetSpellInfo(6346)]  = { id =  6346, cd = 180 },			-- Fear Ward 
        [GetSpellInfo(47788)] = { id = 47788, cd = 180 },			-- Guardian Spirit 
        [GetSpellInfo(64901)] = { id = 64901, cd = 360 },			-- Hymn of Hope 
        [GetSpellInfo(73325)] = { id = 73325, cd = 90 },			-- Leap of Faith
        [GetSpellInfo(33206)] = { id = 33206, cd = 180 },			-- Pain Suppression 
        [GetSpellInfo(62618)] = { id = 62618, cd = 180 },			-- Power Word: Barrier 
        [GetSpellInfo(15487)] = { id = 15487, cd = 45 },			-- Silence
		[GetSpellInfo(47585)] = { id = 47585, cd = 120 },			-- Dispersion
		[GetSpellInfo(108968)] = { id = 108968, cd = 360 },			-- Void Shift
    },

    ["ROGUE"] = { 
        [GetSpellInfo(31224)] = { id = 31224, cd = 120 },			-- Cloak of Shadows
		[GetSpellInfo(1856)]  = { id = 1856, cd = 180 },			-- Vanish
        [GetSpellInfo(57934)] = { id = 57934, cd = 30 },			-- Tricks of the Trade
		[GetSpellInfo(1766)]  = { id = 1766,  cd = 15 },			-- Kick
    },

    ["SHAMAN"] = { 
        [GetSpellInfo(hero)]  = { id = hero,  cd = 300 },			-- Bloodlust/Heroism  
        [GetSpellInfo(16190)] = { id = 16190, cd = 180 },			-- Mana Tide Totem  
        [GetSpellInfo(20608)] = { id = 20608, cd = 1800, ora = 2 },	-- Reincarnation 
		[GetSpellInfo(98008)] = { id = 98008, cd = 180 },			-- Spirit Link Totem
		[GetSpellInfo(51490)] = { id = 51490, cd = 45 },			-- Thunderstorm
		[GetSpellInfo(57994)] = { id = 57994, cd = 12 },			-- Wind Shear
		[GetSpellInfo(108280)] = { id = 108280, cd = 180 },			-- Healing Tide Totem
		[GetSpellInfo(114049)] = { id = 114049, cd = 180 },			-- Ascendance
		[GetSpellInfo(108281)] = { id = 108281, cd = 120 },			-- Ancestral Guidance
		[GetSpellInfo(120668)] = { id = 120668, cd = 300 },			-- Stormlash Totem
    },

    ["WARLOCK"] = { 
        [GetSpellInfo(20707)] = { id = 20707, cd = 600, ora = 3 },	-- Soulstone Resurrection // Possible need to track 6203
		[GetSpellInfo(698)]   = { id =   698, cd = 120 },			-- Ritual of Summoning
		[GetSpellInfo(29893)] = { id = 29893, cd = 120 },			-- Ritual of Souls
		[GetSpellInfo(19647)] = { id = 19647, cd = 24 },			-- Spell Lock
    },

    ["WARRIOR"] = { 
        [GetSpellInfo(12975)] = { id = 12975, cd = 180 },			-- Last Stand  
        [GetSpellInfo(871)]   = { id =   871, cd = 300 },			-- Shield Wall 
        [GetSpellInfo(55694)] = { id = 55694, cd = 60 },			-- Enraged Regeneration
        [GetSpellInfo(355)]   = { id =   355, cd = 8 },				-- Taunt
		[GetSpellInfo(97462)] = { id = 97462, cd = 180 },			-- Rallying Cry
		[GetSpellInfo(6552)]  = { id = 6552,  cd = 15 },			-- Pummel
		[GetSpellInfo(114203)]  = { id = 114203,  cd = 180 },		-- Demoralizing Banner
		[GetSpellInfo(114207)]  = { id = 114207,  cd = 180 },		-- Skull Banner
    }, 
	
	["MONK"] = { 
        [GetSpellInfo(115310)] = { id = 115310, cd = 180 },			-- Revival
		[GetSpellInfo(116849)] = { id = 116849, cd = 120 },			-- Life Cocoon
    }, 
}

local specializationCooldowns = {
	["DRUID"] = {
		["HEALER"] = {
			[GetSpellInfo(740)]   = { id =   740, cd = 180 },		-- Tranquility
		},
	},
}

-- Role constants:
-- HEALER
-- DAMAGER
-- TANK

TrackCooldowns.cooldowns = cooldowns
TrackCooldowns.specializationCooldowns = specializationCooldowns